%define major 10
%define major_xx 4
%define major_mp 3

%define libname %mklibname %{name} %{major}
%define develname %mklibname %{name} -d
%define libname_gmpxx %mklibname %{name}xx %{major_xx}
%define develname_gmpxx %mklibname %{name}xx -d
%define	libname_mp %mklibname %{name}mp %{major_mp} 
%define	develname_mp %mklibname %{name}mp -d

Summary:	A GNU arbitrary precision library
Name:		gmp
Version:	5.0.5
Release:	2
License:	GPLv3
Group:		System/Libraries
URL:		http://gmplib.org/
Source0:	ftp://ftp.gmplib.org/pub/%{name}-%{version}/%{name}-%{version}.tar.xz
Source1:	ftp://ftp.gnu.org/pub/gnu/%{name}-%{version}/%{name}-%{version}.tar.xz.sig
Patch0:		gmp-5.0.5-x32-build-fix.patch
Patch1:		gmp-5.0.5-remove-deprecated-ansi2knr-support.patch
BuildRequires:	bison
BuildRequires:	flex
BuildRequires:	readline-devel
BuildRequires:	ncurses-devel
# XXX this should really be the default behaviour of rpm..
%define	__noautoreqfiles	%{_docdir}

%description
The gmp package contains GNU MP, a library for arbitrary precision
arithmetic, signed integers operations, rational numbers and floating
point numbers. GNU MP is designed for speed, for both small and very
large operands.

GNU MP is fast for several reasons:
   - it uses fullwords as the basic arithmetic type,
   - it uses fast algorithms,
   - it carefully optimizes assembly code for many CPUs' most common
     inner loops
   - it generally emphasizes speed over simplicity/elegance in its
     operations

%package -n	%{libname}
Summary:	A GNU arbitrary precision library
Group:		System/Libraries

%description -n	%{libname}
The gmp package contains GNU MP, a library for arbitrary precision
arithmetic, signed integers operations, rational numbers and floating
point numbers. GNU MP is designed for speed, for both small and very
large operands.

GNU MP is fast for several reasons:
  - it uses fullwords as the basic arithmetic type,
  - it uses fast algorithms
  - it carefully optimizes assembly code for many CPUs' most common
    inner loops
  - it generally emphasizes speed over simplicity/elegance in its
    operations

%package -n	%{develname}
Summary:	Development tools for the GNU MP arbitrary precision library
Group:		Development/C
Requires(post):	rpm-helper
Requires(preun):rpm-helper
Requires:	%{libname} >= %{version}-%{release}
Provides:	%{name}-devel = %{version}-%{release}
Obsoletes:	%{mklibname %{name} 3 -d} < 4.2.4

%description -n	%{develname}
The static libraries, header files and documentation for using the GNU MP
arbitrary precision library in applications.

If you want to develop applications which will use the GNU MP library,
you'll need to install the gmp-devel package.  You'll also need to
install the gmp package.

%package -n	%{libname_gmpxx}
Summary:	C++ support for GMP
Group:		System/Libraries
Requires:	%{libname} >= %{version}-%{release}
Obsoletes:	%mklibname %{name}xx 3

%description -n	%{libname_gmpxx}
C++ support for GMP.

%package -n	%{develname_gmpxx}
Summary:	C++ Development tools for the GMP
Group:		Development/C++
Requires:	%{develname} >= %{version}-%{release}
Requires:	%{libname_gmpxx} >= %{version}-%{release}
Provides:	gmpxx-devel = %{version}-%{release}
Obsoletes:	%{mklibname %{name}xx 4 -d} < 4.2.4

%description -n	%{develname_gmpxx}
C++ Development tools for the GMP.

%package -n	%{libname_mp}
Summary:	Berkley MP compatibility library for GMP
Group:		System/Libraries

%description -n	%{libname_mp}
Berkley MP compatibility library for GMP.

%package -n	%{develname_mp}
Summary:	Development tools for Berkley MP compatibility library for GMP
Group:		Development/C
Requires:	%{libname_mp} >= %{version}-%{release}
Provides:	mp-devel = %{version}-%{release}
Obsoletes:	%{mklibname %{name}mp 3 -d} < 4.2.4

%description -n	%{develname_mp}
Development tools for Berkley MP compatibility library for GMP.

%prep
%setup -q
%patch0 -p1 -b .x32~
%patch1 -p1 -b .no_ansi2knr~
autoreconf -f

%build
%configure2_5x	--enable-cxx \
		--enable-mpbsd \
		--enable-fft
%make

%check
# All tests must pass
make check

%install
%makeinstall_std

%files -n %{libname}
%doc NEWS README
%{_libdir}/libgmp.so.%{major}*

%files -n %{develname}
%doc doc demos
%{_libdir}/libgmp.so
%{_libdir}/libgmp.a
%{_includedir}/gmp.h
%{_infodir}/gmp.info*

%files -n %{libname_gmpxx}
%{_libdir}/libgmpxx.so.%{major_xx}*

%files -n %{develname_gmpxx}
%{_libdir}/libgmpxx.so
%{_libdir}/libgmpxx.a
%{_includedir}/gmpxx.h

%files -n %{libname_mp}
%{_libdir}/libmp.so.%{major_mp}*

%files -n %{develname_mp}
%{_includedir}/mp.h
%{_libdir}/libmp.so
%{_libdir}/libmp.a


%changelog
* Fri Jul 20 2012 Per Øyvind Karlsen <peroyvind@mandriva.org> 5.0.5-2
+ Revision: 810394
- add back static libraries
- prevent automatic dependencies being generated for docs
- remove deprecated automatic de-ANSI-fication support (P1)
- fix x32 build (P0)
- ditch info install scriptlets, this is now automatically handled by triggers
- cleanups
- drop useless non-canonical provides

* Thu May 10 2012 Oden Eriksson <oeriksson@mandriva.com> 5.0.5-1
+ Revision: 798036
- 5.0.5

* Tue Feb 14 2012 Oden Eriksson <oeriksson@mandriva.com> 5.0.4-1
+ Revision: 773957
- 5.0.4

* Sat Jan 28 2012 Oden Eriksson <oeriksson@mandriva.com> 5.0.3-1
+ Revision: 769494
- 5.0.3

  + Paulo Andrade <pcpa@mandriva.com.br>
    - Remove sagemath double free patch as problem was properly corrected.

* Sat Dec 03 2011 Oden Eriksson <oeriksson@mandriva.com> 5.0.2-2
+ Revision: 737460
- drop the static libs and the libtool *.la files
- various fixes

* Thu May 12 2011 Oden Eriksson <oeriksson@mandriva.com> 5.0.2-1
+ Revision: 673760
- 5.0.2

* Tue May 03 2011 Oden Eriksson <oeriksson@mandriva.com> 5.0.1-4
+ Revision: 664856
- mass rebuild

* Mon Mar 14 2011 Paulo Andrade <pcpa@mandriva.com.br> 5.0.1-3
+ Revision: 644676
- Add workaround for a double free that may happen in the sagemath package

* Thu Dec 02 2010 Oden Eriksson <oeriksson@mandriva.com> 5.0.1-2mdv2011.0
+ Revision: 605467
- rebuild

* Tue Feb 09 2010 Funda Wang <fwang@mandriva.org> 5.0.1-1mdv2010.1
+ Revision: 502595
- libso version change ( 3->10 ), which should happen in 5.0.0
- new version 5.0.1

* Sun Jan 31 2010 Oden Eriksson <oeriksson@mandriva.com> 5.0.0-1mdv2010.1
+ Revision: 498806
- 5.0.0

* Fri Jan 08 2010 Emmanuel Andry <eandry@mandriva.org> 4.3.2-1mdv2010.1
+ Revision: 487742
- New version 4.3.2
- fix URL and SOURCE

* Thu May 14 2009 Frederik Himpe <fhimpe@mandriva.org> 4.3.1-1mdv2010.0
+ Revision: 375706
- update to new version 4.3.1

* Sat May 02 2009 Tomasz Pawel Gajc <tpg@mandriva.org> 4.3.0-1mdv2010.0
+ Revision: 370725
- update to new version 4.3.0

* Thu Dec 25 2008 Oden Eriksson <oeriksson@mandriva.com> 4.2.4-3mdv2009.1
+ Revision: 318481
- rebuild

* Tue Nov 11 2008 Funda Wang <fwang@mandriva.org> 4.2.4-2mdv2009.1
+ Revision: 302043
- fix devel package requires

* Sun Sep 28 2008 Tomasz Pawel Gajc <tpg@mandriva.org> 4.2.4-1mdv2009.1
+ Revision: 289068
- new license policy
- new devel library policy
- add missing buildrequires
- update to new version 4.2.4

* Thu Aug 07 2008 Tomasz Pawel Gajc <tpg@mandriva.org> 4.2.3-1mdv2009.0
+ Revision: 265366
- update to new version 4.2.3

* Tue Jun 17 2008 Thierry Vignaud <tv@mandriva.org> 4.2.2-2mdv2009.0
+ Revision: 221073
- rebuild
- kill re-definition of %%buildroot on Pixel's request

  + Pixel <pixel@mandriva.com>
    - do not call ldconfig in %%post/%%postun, it is now handled by filetriggers

  + Olivier Blin <blino@mandriva.org>
    - restore BuildRoot

* Fri Oct 12 2007 Tomasz Pawel Gajc <tpg@mandriva.org> 4.2.2-1mdv2008.1
+ Revision: 97233
- new release
- spec file clean

